<?php
class Dashboard extends Controller {

    function Dashboard()
    {
        parent::Controller();
        
        $this->load->library('encrypt');
        $this->load->helper('url');
        $this->load->helper('cookie');
        $this->load->model('management');
        $this->management->online_members();
        $this->lang->load('language', 'english');
    }
    
    function index()
    {
        if ($this->session->userdata('logged') != TRUE) redirect('index.php/login');
        
        /* project management install settings */
        include('install.settings.php');
        
        /* general data */
        $data['title']           = $install['title'].' - '.$this->lang->line('dashboard');
        $data['template']        = base_url()."system/application/views/management/";
        $data['session_iduser']  = $this->session->userdata('username');
        $data['session_acces']   = $this->session->userdata('acces');
        $data['members']         = $this->db->query("SELECT * FROM members ORDER BY id_user ASC");
        $data['categories']      = $this->db->query("SELECT * FROM categories ORDER BY id_cat ASC");
        $data['task_number']     = $this->management->member_tasks();
        $data['new_tasks']       = $this->management->newtasks_access(1);
        $data['membername']      = $this->management->newtasks_access(0);
        $data['pm_version']      = "PM v.1.2 - ";
        
        $this->load->view('management/dashboard', $data);
    }

    function view_controller($type = NULL)
    {
        /* project management install settings */
        include('install.settings.php');
    
        /* general data */
        $data['session_iduser'] = $this->session->userdata('username');
        $data['session_acces']  = $this->session->userdata('acces');
        $data['categories']     = $this->db->query("SELECT * FROM categories ORDER BY id_cat ASC");
        $data['new_tasks']      = $this->management->newtasks_access(1);
        $data['membername']     = $this->management->newtasks_access(0);
        $data['pm_version']     = "PM v.1.1 - ";
        $data['demo']           = (isset($install['demo']))? $install['demo']:0;
        
        if ($type == "box_categories")
        {
            $data['controller_type'] = $type;
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_categories_manage") {
            
            $data['controller_type'] = $type;
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_member_modify") {
            
            $data['controller_type'] = $type;
            $data['iduser']          = $this->uri->segment(4);
            $data['member']          = $this->db->query("SELECT * FROM members WHERE id_user='".$data['iduser']."'");
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_project_modify") {
            
            $data['controller_type'] = $type;
            $data['id_project']      = $this->uri->segment(4);
            $data['categories']      = $this->db->query("SELECT * FROM categories ORDER BY id_cat ASC");
            $data['project']         = $this->db->query("SELECT * FROM projects WHERE id_project='".$data['id_project']."'");
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_project_delete") {
            
            $data['controller_type'] = $type;
            $data['id_project']      = $this->uri->segment(4);
            $data['project']         = $this->db->query("SELECT * FROM projects WHERE id_project='".$data['id_project']."'");
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_tasks_update") {
        
            $data['controller_type'] = $type;
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_calendar") {
            
            require_once("class.calendar.php");
            
            $data['controller_type'] = $type;
            $data['month']           = $this->uri->segment(4);
            $data['year']            = $this->uri->segment(5);
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_member_details") {
            
            $data['controller_type'] = $type;
            $data['id_user']         = $this->uri->segment(4);
            $data['demo']            = (isset($install['demo']))? $install['demo']:0;
            $data['member']          = $this->db->query("SELECT * FROM members WHERE id_user='".$data['id_user']."'");
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_member_online") {
            
            $data['controller_type'] = $type;
            $data['members']         = $this->db->query("SELECT * FROM members ORDER BY id_user ASC");
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_member_tasknr") {
            
            $data['controller_type'] = $type;
            $data['nr_tasks']        = $this->management->member_tasks();
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_dashboard") {
        
            $this->load->view('management/ajax_dashboard', $data);
            
        } else if ($type == "tab_archive") {
            
            $data['id_archive']    = $this->uri->segment(4);
            $data['interval']      = $this->uri->segment(5);
            
            $this->load->view('management/ajax_archive', $data);
            
        } else if ($type == "box_mytasks") {
            
            $id_user = $this->session->userdata('username');
            $data['id_user']  = $id_user;
            $data['projects'] = $this->db->query("SELECT DISTINCT projects.id_project,projects.name_project, projects.description, projects.deadline FROM projects, tasks_group, tasks WHERE projects.break!='1' AND tasks_group.id_group = tasks.id_group AND projects.id_project = tasks_group.id_project AND tasks.id_user='".$id_user."' AND tasks.status='0' ORDER BY projects.deadline ASC");
            
            $user_tasks = $this->db->query("SELECT COUNT(*) as number FROM projects, tasks_group, tasks WHERE projects.break != '1' AND tasks_group.id_project=projects.id_project AND tasks_group.id_group=tasks.id_group AND tasks.id_user='".$id_user."' AND tasks.status='0'");
            
            $grammer  = ($user_tasks->row()->number == 1)? $this->lang->line('task_grammer1'):$this->lang->line('task_grammer2');
            
            /* mytasks number message */
            $search    = array('{TASKNUMBER}', '{GRAMMER_TASK}');
            $replace   = array($user_tasks->row()->number, $grammer);
            $mytasks_msg = str_replace($search, $replace, $this->lang->line('mytasks_number'));
            
            $texttask = ($user_tasks->row()->number > 0)? $mytasks_msg : $this->lang->line('notask_formember');
            
            $data['task_number'] = $texttask;
            
            $this->load->view('management/ajax_tasks', $data);
            
        } else if ($type == "box_tasks_remaining") {
        
            $nr_tasks    = $this->management->member_tasks();
            $grammer     = ($nr_tasks == 1)? $this->lang->line('task_grammer1'):$this->lang->line('task_grammer2');
            
            /* mytasks number message */
            $search      = array('{TASKNUMBER}', '{GRAMMER_TASK}');
            $replace     = array($nr_tasks, $grammer);
            $mytasks_msg = str_replace($search, $replace, $this->lang->line('mytasks_number'));
            
            $output      = ($nr_tasks > 0)? $mytasks_msg : $this->lang->line('notask_formember');
            
            echo $output;
            
        } else if ($type == "box_tasks_operations") {
            
            $data['controller_type'] = $type;
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_categories_content") {
            
            $data['controller_type'] = $type;
            $data['hidden']          = $this->uri->segment(4);
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_project_search") {
            
            $data['controller_type'] = $type;
            $data['projects_found']  = $this->uri->segment(4);
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_archive_period") {
            
            $data['controller_type'] = $type;
            $data['interval']        = $this->uri->segment(4);
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_project_category") {
            
            $data['controller_type'] = $type;
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_project") {
            
            $data['controller_type'] = $type;
            $data['id_category']    = $this->uri->segment(4);
            $data['id_project']      = $this->uri->segment(5);
            $data['project']         = $this->db->query("SELECT * FROM projects WHERE id_project='".$data['id_project']."' AND id_cat='".$data['id_category']."'");
            $data['task_group']      = $this->db->query("SELECT * FROM tasks_group WHERE id_project='".$data['id_project']."' ORDER BY deadline ASC");
            $data['percentage']      = $this->management->project_percentage($data['id_project']);
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_grouptask_add") {
            
            $data['controller_type'] = $type;
            $data['id_category']     = $this->uri->segment(4);
            $data['id_project']      = $this->uri->segment(5);
            $data['members']         = $this->db->query("SELECT * FROM members ORDER BY name ASC");
            
            $project = $this->db->query("SELECT name_project FROM projects WHERE id_project='".$data['id_project']."'");
            $data['project']         = $project->row()->name_project;
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_project_progress") {
            
            $data['controller_type'] = $type;
            $data['id_project']      = $this->uri->segment(4);
            $data['mask']            = $this->uri->segment(5);
            $data['percentage']      = $this->management->project_percentage($data['id_project']);
            
            $this->load->view('management/ajax_controller', $data);
        
        } else if ($type == "box_task_complete") {
            
            $data['controller_type']  = $type;
            $data['id_group']         = $this->uri->segment(4);
            
            $tasks_nr       = $this->db->query("SELECT COUNT(*) as number FROM tasks WHERE id_group='".$data['id_group']."'");
            $tasks_complete = $this->db->query("SELECT COUNT(*) as number FROM tasks WHERE id_group='".$data['id_group']."' AND status='1'");
            $task_group     = $this->db->query("SELECT deadline FROM tasks_group WHERE id_group='".$data['id_group']."' LIMIT 1");
            
            /* project progress language */
            $search    = array('{TASKCOMPLETE}', '{TASKNUMBER}');
            $replace   = array($tasks_complete->row()->number, $tasks_nr->row()->number);
            $progress_language = str_replace($search, $replace, $this->lang->line('project_progress'));
            
            $data['tasks_complete'] = $this->lang->line('project_deadline').': '.date("m-d-Y", $task_group->row()->deadline).' '.$progress_language;
            
            $this->load->view('management/ajax_controller', $data);

        } else if ($type == "box_grouptask_responsable") {
            
            $data['controller_type'] = $type;
            $data['id_group']        = $this->uri->segment(4);
            
            $this->load->view('management/ajax_controller', $data);
            
        } else if ($type == "box_package_modify") {
            
            $data['controller_type'] = $type;
            $data['id_type']         = $this->uri->segment(4);
            $data['id_package']      = $this->uri->segment(5);
            
            $this->load->view('management/ajax_controller', $data);

        } else if ($type == "box_grouptask_modify") {
            
            $data['controller_type'] = $type;
            $data['id_group']        = $this->uri->segment(4);
            $data['id_project']      = $this->uri->segment(5);
            $data['members']         = $this->db->query("SELECT * FROM members ORDER BY name ASC");
            
            $this->load->view('management/ajax_controller', $data);
            
        } else {
            
            $this->load->view('management/dashboard', $data);
        }
        
    }
    
    function add_member()
    {
        if(isset($_POST)) {
          
            $data['name']      = $this->management->clearvariable($_POST['name']);
            $data['username']  = $this->management->clearvariable($_POST['username']);
            $data['ocupation'] = $this->management->clearvariable($_POST['ocupation']);
            $data['email']     = $this->management->clearvariable($_POST['email']);
            $data['phone']     = $this->management->clearvariable($_POST['phone']);
            $data['password1'] = $this->management->clearvariable($_POST['password1']);
            $data['password2'] = $this->management->clearvariable($_POST['password2']);
            $data['acces']     = $this->management->clearvariable($_POST['access']);

            echo $this->management->add_member($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function modify_member()
    {
        if(isset($_POST)) {
        
            $data['name']      = $this->management->clearvariable($_POST['name']);
            $data['username']  = $this->management->clearvariable($_POST['username']);
            $data['ocupation'] = $this->management->clearvariable($_POST['ocupation']);
            $data['email']     = $this->management->clearvariable($_POST['email']);
            $data['phone']     = $this->management->clearvariable($_POST['phone']);
            $data['password1'] = $this->management->clearvariable($_POST['password1']);
            $data['password2'] = $this->management->clearvariable($_POST['password2']);
            $data['id_user']   = $this->management->clearvariable($_POST['id_user']);
            $data['acces']     = $this->management->clearvariable($_POST['acces']);

            echo $this->management->modify_member($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function delete_member()
    {
        if(isset($_POST)) {
        
            $data['id_user'] = $this->management->clearvariable($_POST['id_user']);
            
            echo $this->management->delete_member($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function add_category()
    {
        if(isset($_POST)) {
        
            $data['category'] = $this->management->clearvariable($_POST['category']);
            
            echo $this->management->add_category($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function modify_category()
    {
        if(isset($_POST)) {
        
            $data['id_cat']        = $this->management->clearvariable($_POST['id_cat']);
            $data['category_name'] = $this->management->clearvariable($_POST['category_name']);
            
            echo $this->management->modify_category($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function delete_category()
    {
        if(isset($_POST)) {
        
            $data['id_cat'] = $this->management->clearvariable($_POST['id_cat']);
            
            echo $this->management->delete_category($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function add_project()
    {
        if(isset($_POST)) {
        
            $data['name']        = $this->management->clearvariable($_POST['name']);
            $data['description'] = $this->management->clearvariable($_POST['description']);
            $data['category']    = $this->management->clearvariable($_POST['category']);
            $data['deadline']    = $this->management->clearvariable($_POST['deadline']);
            
            echo $this->management->add_project($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function modify_project()
    {
        if(isset($_POST)) {
        
            $data['name']        = $this->management->clearvariable($_POST['name']);
            $data['description'] = $this->management->clearvariable($_POST['description']);
            $data['category']    = $this->management->clearvariable($_POST['category']);
            $data['deadline']    = $this->management->clearvariable($_POST['deadline']);
            $data['id_project']  = $this->management->clearvariable($_POST['id_project']);
            
            echo $this->management->modify_project($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function delete_project()
    {
        if(isset($_POST)) {
        
            $data['id_project'] = $this->management->clearvariable($_POST['id_project']);
            
            echo $this->management->delete_project($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function status_project()
    {
        if(isset($_POST)) {
        
            $data['status']     = $this->management->clearvariable($_POST['status']);
            $data['activ']      = $this->management->clearvariable($_POST['activ']);
            $data['id_project'] = $this->management->clearvariable($_POST['id_project']);
            
            echo $this->management->status_project($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }

    function add_task()
    {
        if(isset($_POST)) {
        
            $data['name']        = $this->management->clearvariable($_POST['name']);
            $data['deadline']    = $this->management->clearvariable($_POST['deadline']);
            $data['task']        = $this->management->clearvariable($_POST['task']);
            $data['membru']      = $this->management->clearvariable($_POST['membru']);
            $data['id_project']  = $this->management->clearvariable($_POST['id_project']);
            $data['id_category'] = $this->management->clearvariable($_POST['id_category']);
            $data['fieldnumber'] = $this->management->clearvariable($_POST['number_fieldtask']);

            echo $this->management->add_taskgroup($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function modify_taskgroup()
    {
        if(isset($_POST)) {
        
            $data['name']           = $this->management->clearvariable($_POST['name']);
            $data['deadline']       = $this->management->clearvariable($_POST['deadline']);
            
            $data['idtask']         = $this->management->clearvariable($_POST['idtask']);
            $data['task']           = $this->management->clearvariable($_POST['task']);
            $data['membru']         = $this->management->clearvariable($_POST['membru']);
            
            $data['newtask']        = $this->management->clearvariable($_POST['newtask']);
            $data['newmember']      = $this->management->clearvariable($_POST['newmember']);
            
            $data['id_project']     = $this->management->clearvariable($_POST['id_project']);
            $data['id_category']    = $this->management->clearvariable($_POST['id_category']);
            $data['id_group']       = $this->management->clearvariable($_POST['id_group']);
            $data['fieldnumber']    = $this->management->clearvariable($_POST['number_fieldtask']);
            $data['newfieldnumber'] = $this->management->clearvariable($_POST['newnumber_fieldtask']);
            
            echo $this->management->modify_taskgroup($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function update_task()
    {
        if(isset($_POST)) {
        
            $data['idtask']  = $this->management->clearvariable($_POST['idtask']);
            $data['status']  = $this->management->clearvariable($_POST['status']);
            
            echo $this->management->update_task($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function update_groupname()
    {
        if(isset($_POST)) {
        
            $data['id_group']   = $this->management->clearvariable($_POST['id_group']);
            $data['group_name'] = $this->management->clearvariable($_POST['group_name']);
            
            echo $this->management->update_groupname($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function delete_grouptasks()
    {
        if(isset($_POST)) {
        
            $data['id_group'] = $this->management->clearvariable($_POST['id_group']);
            
            echo $this->management->delete_grouptasks($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function modify_task()
    {
        if(isset($_POST)) {
        
            $data['idtask']    = $this->management->clearvariable($_POST['idtask']);
            $data['task_name'] = $this->management->clearvariable($_POST['task_name']);
            $data['membru']    = $this->management->clearvariable($_POST['membru']);
            
            echo $this->management->modify_task($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function delete_task()
    {
        if(isset($_POST)) {
        
            $data['idtask']   = $this->management->clearvariable($_POST['idtask']);
            $data['id_group'] = $this->management->clearvariable($_POST['id_group']);
            
            echo $this->management->delete_task($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function search_project()
    {
        if(isset($_POST)) {
        
            $data['searched_word'] = $this->management->clearvariable($_POST['searched_word']);
            
            echo $this->management->search_project($data);
            
        } else { redirect('index.php/management/dashboard'); }
    }
    
    function upload_image()
    {
        if(isset($_POST)) {
            
            sleep(1); 
            $rand = rand(5000, 10000);
            
            $upload_src = 'system/application/views/management/avatar/';
            $id_user    = $_POST['id_user'];
            $old_photo  = $_POST['photo'];
            
            $new_photo             = basename($rand.$_FILES['userfile']['name']);
            $load_photo            = $upload_src . $new_photo;
            $delete_photo_src      = $upload_src . $old_photo;
            $delete_thumbphoto_src = $upload_src."thumb_".$old_photo;
            
            if($old_photo != '0' && $old_photo != $new_photo) { 
                unlink($delete_photo_src);
                unlink($delete_thumbphoto_src);
            }

            if (move_uploaded_file($_FILES['userfile']['tmp_name'], $load_photo)) {
                $query = $this->db->query("UPDATE members SET photo='".$new_photo."' WHERE id_user='".$id_user."'");
            } else {
                //null
            }
            
            include("class.resize.php");
            $imagine_resize26 = $upload_src."thumb_".$new_photo;
            $imagine_resize90 = $upload_src.$new_photo;
            
            $resizeObj = new resize($load_photo);
            $resizeObj -> resizeImage(26, 26, 'crop'); //(options: exact, portrait, landscape, auto, crop)
            $resizeObj -> saveImage($imagine_resize26, 100);
            
            $resizeObj -> resizeImage(90, 90, 'crop'); //(options: exact, portrait, landscape, auto, crop)
            $resizeObj -> saveImage($imagine_resize90, 100);
        }
    }
    
    function checklogin()
    {
        if(isset($_POST)) {
        
            $logged = ($this->session->userdata('logged') != TRUE)? 1:0;
            $result = ($logged == 0)? array("result" => "ok", "result_message" => "0"):array("result" => "ok", "result_message" => "1");
            echo json_encode($result);
            
        } else { redirect('index.php/management/dashboard'); }
    }
}
?>