<?php
class Login extends Controller 
{
    
    function Login()
    {
        parent::Controller();
        $this->load->library('encrypt');
        $this->load->helper('cookie');
        $this->load->helper('url');
        $this->load->model('management');
        $this->lang->load('language', 'english');
    }
    
    function index()
    {
        if(get_cookie('login'))
        {
            $cookie    = explode("|||",get_cookie('login'));
            $id_user   = $cookie[0];
            $password  = $cookie[1];
            $acces     = $cookie[2];
            
            $query = $this->db->get_where('members', array('id_user' => $id_user, 'password' => $password));
            if($query->num_rows() > 0)
            {
                $data = array('username' => $id_user, 'acces' => $acces, 'logged' => TRUE);
                $this->session->set_userdata($data);
                redirect('index.php/dashboard');
                
            } else {
                delete_cookie("login");
                redirect('index.php/login');
            }
            
        } else {
        
            if($this->session->userdata('logged') == TRUE) redirect('index.php/dashboard');
            
            /* project management install settings */
            include('install.settings.php');
            
            $data['title']    = $install['title']." - Login";
            $data['template'] = base_url()."system/application/views/management/";
            $data['demo']     = (isset($install['demo']))? $install['demo']:0;
            $this->load->view('management/login', $data);
        }
    }
    
    function authentication()
    {
        /* project management install settings */
        include('install.settings.php');
        
        /* variables from the form */
        $username  = $this->management->clearvariable($this->input->post('username'));
        $password  = $this->management->clearvariable($this->input->post('password'));
        $remember  = $this->management->clearvariable($this->input->post('remember'));
        
        $nr_user = $this->db->query("SELECT COUNT(*) as nr FROM members WHERE user='".$username."'");
        
        if ($username != '' AND $password != '' AND $nr_user->row()->nr > 0)
        {
            $query = $this->db->query("SELECT id_user, password, acces FROM members WHERE user='".$username."'");
            $password_db = $query->row()->password;
            $password_na = ($password_db == 'admin')? 'admin':$this->encrypt->decode($password_db);
            
            if($query->num_rows() > 0 && $password == $password_na)
            {
                $data = array('username' => $query->row()->id_user, 'acces' => $query->row()->acces, 'logged' => TRUE);
                $this->session->set_userdata($data);
                $id_user = $query->row()->id_user;
                $acces   = $query->row()->acces;
                
                /* remember-me module */
                if(!empty($remember))
                {
                    $cookie = array(
                       'name'   => 'login',
                       'value'  => $id_user."|||".$password_db."|||".$acces,
                       'expire' => time()+2592000, //86400 = 1day
                       'domain' => '.'.$install['base_domain'],
                       'path'   => '/'.$install['base_path'],
                       'prefix' => '',
                    );
                    set_cookie($cookie);
                }
                redirect('index.php/dashboard');
                
            } else {
            
                /* username or password - incorect - redirect to login  */
                $this->session->set_flashdata('error-message', '<div class="message-error">'.$this->lang->line('login_error_invaliduser').'</div>');
                redirect('index.php/login');
            }
        }
        else {
        
            /* blank fields - redirect to login */
            $error = ($nr_user->row()->nr > 0) ? $this->lang->line('login_error_emptyfileds') : $this->lang->line('login_error_notexistuser');
            $this->session->set_flashdata('error-message', '<div class="message-error">'.$error.'</div>');
            redirect('index.php/login');
        }
    }
    
    function logout()
    {
        /* project management install settings */
        include('install.settings.php');
        
        $sessions = array('username' => '', 'acces' => '', 'logged' => '');
        $this->session->unset_userdata($sessions);
        $this->session->sess_destroy();
        delete_cookie('login', $install['base_domain'], '/'.$install['base_path'], '');
        redirect('index.php/login');
    }
    
}
?>