<?php

class Management extends Model
{
    function clearvariable($value) 
    {
        $value = trim($value);
        $value = str_replace("\t"," ",$value);
        $value = strip_tags($value);
        $value = addslashes($value);
        return $value;
    }
    
    function cleaninput($value) 
    {
        $value=str_replace('"',"&#34;",$value);
        return $value;
    }
    
    function cleaninputdata($value) 
    {
        $value = stripslashes($value);
        return $value;
    }
    
    function setValue($value)
    {
        return 'onblur="if(this.value==\'\')this.value=\''.$value.'\';" onfocus="if(this.value==\''.$value.'\')this.value=\'\';"';
    }
    
    function descriptionSpan($project_name,$project_description)
    {
        /* description substr */
        $ratio        = 1.6;
        $len_title    = strlen($project_name) * $ratio;
        $len_dscp_max = 100 - $len_title;
        
        if(strlen($project_description) > $len_dscp_max)
        {
            $description       = substr($project_description, 0, $len_dscp_max-3)."...";
            $class_tooltip     = " tooltip";
            $title_description = ' title="'.$this->management->cleaninput($project_description).'"';
            
        } else {
            $description   = $project_description;
            $class_tooltip = $title_description = "";
        }
        
        return '<span class="description'.$class_tooltip.'"'.$title_description.'>'.$description.'</span>';
    }
    
    function search_project($data)
    {
        $errors = "";
        $search_string = $data['searched_word'];
        
        $word = trim($search_string);
        $word = preg_replace("/\s\s+/" , " " , $word);
        $word = explode(" ", $word);

        $word_numer = count($word);

        $likestring = "";
        if($word_numer > 1)
        {
            $likestring .= "LIKE '%$word[0]%'";
            for($i=1; $i<$word_numer; $i++)
            {
                $likestring .= " AND name_project LIKE '%$word[$i]%'";
            }
            
        } else {
            $likestring .= "LIKE '%".$word[0]."%'";
        }
        
        $projects       = $this->db->query("SELECT * FROM projects WHERE name_project $likestring");
        $found_projects = $this->db->query("SELECT COUNT(*) as number FROM projects WHERE name_project $likestring");
        
        if($found_projects->row()->number < 1) $errors .= "0"."\n";
        
        $list_projects = "";
        foreach($projects->result() as $project):
            $list_projects .= $project->id_project."-";
        endforeach;
        $list_projects = substr($list_projects, 0, -1);
        
        if($errors == "") $result = array("result" => "ok", "result_message" => $list_projects); else $result = array("result" => "null", "result_message" => "$errors");
        
        return json_encode($result);
    }
    
    function add_project($data)
    {
        $errors = "";
        if($data['name'] == "" || $data['name'] == $this->lang->line('project_name'))
        {
            $errors .= "<li>".$this->lang->line('empty_projectname')."</li>"."\n";
        }
        
        if($data['description'] == "" || $data['description'] == $this->lang->line('project_description'))
        {
            $errors .= "<li>".$this->lang->line('empty_projectdescription')."</li>"."\n";
        }
        
        if($data['deadline'] == "" || $data['deadline'] == $this->lang->line('project_deadline'))
        {
            $errors .= "<li>".$this->lang->line('empty_projectdeadline')."</li>"."\n";
        }
        
        if($data['category'] == "" || $data['category'] == "0")
        {
            $errors .= "<li>".$this->lang->line('empty_projectcategory')."</li>"."\n";
        }
        
        $proiect_altnume = $this->db->query("SELECT COUNT(*) as nr FROM projects WHERE name_project='".$data['name']."' AND id_cat='".$data['category']."'");
        if($proiect_altnume->row()->nr > 0)
        {
            $errors .= "<li>".$this->lang->line('duplicate_projectname')."</li>"."\n";
        }
        
        if($errors == "")
        {
            $segment_date = explode("-", $data['deadline']);
            $deadline = mktime(0, 0, 0, $segment_date[0], $segment_date[1], $segment_date[2]);
            
            $query = $this->db->query("INSERT INTO projects (id_cat, name_project, description, deadline, timestamp) VALUES('".$data['category']."', '".$data['name']."', '".$data['description']."', '".$deadline."', '".time()."')");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_projectadd')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }

        return json_encode($result);
    }
    
    function modify_project($data)
    {
        $errors = "";
        if($data['name'] == "" || $data['name'] == $this->lang->line('project_name'))
        {
            $errors .= "<li>".$this->lang->line('empty_projectname')."</li>"."\n";
        }
        
        if($data['category'] == "" || $data['category'] == "0")
        {
            $errors .= "<li>".$this->lang->line('empty_projectcategory')."</li>"."\n";
        }
        
        $project_newname = $this->db->query("SELECT COUNT(*) as nr FROM projects WHERE name_project='".$data['name']."' AND id_cat='".$data['category']."'");
        $project_name = $this->db->query("SELECT name_project FROM projects WHERE id_project='".$data['id_project']."'");

        if($project_newname->row()->nr > 0 && $project_name->row()->name_project != $this->management->cleaninputdata($data['name']))
        {
            $errors .= "<li>".$this->lang->line('duplicate_projectname')."</li>"."\n";
        }
        
        if($data['description'] == "" || $data['description'] == $this->lang->line('project_description'))
        {
            $errors .= "<li>".$this->lang->line('empty_projectdescription')."</li>"."\n";
        }
        
        if($data['deadline'] == "" || $data['deadline'] == $this->lang->line('project_deadline'))
        {
            $errors .= "<li>".$this->lang->line('empty_projectdeadline')."</li>"."\n";
        }
        
        if($errors == "")
        {
            $segment_date = explode("-", $data['deadline']);
            $deadline = mktime(0, 0, 0, $segment_date[0], $segment_date[1], $segment_date[2]);
            
            $query = $this->db->query("UPDATE projects SET id_cat='".$data['category']."', name_project='".$data['name']."', description='".$data['description']."', deadline='".$deadline."' WHERE id_project='".$data['id_project']."'");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_projectmodify')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function delete_project($data)
    {
        $errors = "";
        $project = $this->db->query("SELECT COUNT(*) as nr FROM projects WHERE id_project='".$data['id_project']."'");
        if($project->row()->nr < 1)
        {
            $errors .= "<li>".$this->lang->line('invalid_projectid')."</li>"."\n";
        }
        
        if($errors == "")
        {
            $groups         = $this->db->query("SELECT COUNT(*) as nr FROM tasks_group WHERE id_project='".$data['id_project']."'");
            $delete_project = $this->db->query("DELETE FROM projects WHERE id_project='".$data['id_project']."'");
            
            if($groups->row()->nr > 0)
            {
                $task_group = $this->db->query("SELECT id_group FROM tasks_group WHERE id_project='".$data['id_project']."'");
                foreach($task_group->result() as $gruptask):
                    
                    $delete_group = $this->db->query("DELETE FROM tasks_group WHERE id_group='".$gruptask->id_group."'");
                    $delete_task  = $this->db->query("DELETE FROM tasks WHERE id_group='".$gruptask->id_group."'");

                endforeach;
            }

            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_projectdelete')."</li></ul>");
            
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }

        return json_encode($result);
    }
    
    function status_project($data)
    {
        $errors = "";
        
        if($errors == "")
        {
            $status = ($data['status'] == 'paused') ? "break" : "status";
            $update = $this->db->query("UPDATE projects SET $status='".$data['activ']."' WHERE id_project='".$data['id_project']."'");
            
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_projectmodify')."</li></ul>");
            
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }

        return json_encode($result);
    }
    
    function add_member($data)
    {
        $errors = "";
        
        if($data['name'] == "" || $data['name'] == $this->lang->line('name_and_surname'))
        {
            $errors .= "<li>".$this->lang->line('empty_membername')."</li>"."\n";
        }
        
        if($data['username'] == "" || $data['username'] == $this->lang->line('username'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberusername')."</li>"."\n";
        }
        
        if($data['acces'] == "" || $data['acces'] == "0")
        {
            $errors .= "<li>".$this->lang->line('empty_memberaccess')."</li>"."\n";
        }
        
        $verificauser = $this->db->query("SELECT COUNT(*) as nruser FROM members WHERE user='".$data['username']."'");
        if($verificauser->row()->nruser > 0)
        {
            $errors .= "<li>".$this->lang->line('duplicate_memberusername')."</li>"."\n";
        }
        
        if($data['ocupation'] == "" || $data['ocupation'] == $this->lang->line('member_ocupation'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberposition')."</li>"."\n";
        }
        
        if($data['email'] == "" || $data['email'] == $this->lang->line('member_email'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberemail')."</li>"."\n";
        }
        
        if($data['phone'] == "" || $data['phone'] == $this->lang->line('member_phone'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberphone')."</li>"."\n";
        }
        
        if($data['password1'] == "" || $data['password1'] == "123456789")
        {
            $errors .= "<li>".$this->lang->line('empty_memberpassword1')."</li>"."\n";
        }
        
        if($data['password2'] == "" || $data['password2'] == "123456789")
        {
            $errors .= "<li>".$this->lang->line('empty_memberpassword2')."</li>"."\n";
        }
        
        if($data['password1'] != $data['password2'])
        {
            $errors .= "<li>".$this->lang->line('nomatch_memberpassword')."</li>"."\n";
        }
        
        if($errors == "")
        {
            $password = $this->encrypt->encode($data['password1']);
            $query = $this->db->query("INSERT INTO members (name, user, position, email, phone, password, acces) VALUES('".$data['name']."', '".$data['username']."', '".$data['ocupation']."', '".$data['email']."', '".$data['phone']."', '".$password."', '".$data['acces']."')");
            $id_user = $this->db->insert_id();
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_memberadd')."</li></ul>", "id_user" => $id_user);
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }

        return json_encode($result);
    }
    
    function modify_member($data)
    {
        $errors = "";
        if($data['name'] == "" || $data['name'] == $this->lang->line('name_and_surname'))
        {
            $errors .= "<li>".$this->lang->line('empty_membername')."</li>"."\n";
        }
        
        if($data['username'] == "" || $data['username'] == $this->lang->line('username'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberusername')."</li>"."\n";
        }
        
        $verify_user = $this->db->query("SELECT COUNT(*) as nruser FROM members WHERE user='".$data['username']."'");
        $username = $this->db->query("SELECT user FROM members WHERE id_user='".$data['id_user']."'");
        
        if($username->row()->user != $data['username'] && $verify_user->row()->nruser > 0)
        {
            $errors .= "<li>".$this->lang->line('duplicate_memberusername')."</li>"."\n";
        }
        
        if($data['ocupation'] == "" || $data['ocupation'] == $this->lang->line('member_ocupation'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberposition')."</li>"."\n";
        }
        
        if($data['email'] == "" || $data['email'] == $this->lang->line('member_email'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberemail')."</li>"."\n";
        }
        
        if($data['phone'] == "" || $data['phone'] == $this->lang->line('member_phone'))
        {
            $errors .= "<li>".$this->lang->line('empty_memberphone')."</li>"."\n";
        }
        
        if($data['password1'] != $data['password2'])
        {
            $errors .= "<li>".$this->lang->line('nomatch_memberpassword')."</li>"."\n";
        }
        
        if($this->session->userdata('acces') == '1')
        {
            if($data['acces'] == "" || $data['acces'] == "0")
            {
                $errors .= "<li>".$this->lang->line('empty_memberaccess')."</li>"."\n";
            }
        }
        
        if($errors == "")
        {
            $encrypted_password = $this->encrypt->encode($data['password1']);
            $password = ($data['password1'] != "123456789" && $data['password2'] != "123456789") ? ", password='$encrypted_password'" : "";
            $acces = ($this->session->userdata('acces') == '1') ? ", acces='".$data['acces']."'" : "";
            $query = $this->db->query("UPDATE members SET name='".$data['name']."', user='".$data['username']."', position='".$data['ocupation']."', email='".$data['email']."', phone='".$data['phone']."' $acces $password WHERE id_user='".$data['id_user']."'");
            
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_membermodify')."</li></ul>");
            
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }

        return json_encode($result);
    }
    
    function delete_member($data)
    {
        $errors = "";
        $member = $this->db->query("SELECT COUNT(*) as nr FROM members WHERE id_user='".$data['id_user']."'");
        if($member->row()->nr < 1)
        {
            $errors .= "<li>".$this->lang->line('invalid_memberid')."</li>"."\n";
        }
        
        if($errors == "")
        {
            $delete_member = $this->db->query("DELETE FROM members WHERE id_user='".$data['id_user']."'");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_memberdelete')."</li></ul>");
            
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }

        return json_encode($result);
    }
    
    function add_category($data)
    {
        $errors = "";
        if($data['category'] == "" || $data['category'] == $this->lang->line('category_name'))
        {
            $errors .= "<li>".$this->lang->line('empty_categoryname')."</li>"."\n";
        }
        
        $category_name = $this->db->query("SELECT COUNT(*) as number FROM categories WHERE name_cat='".$data['category']."'");
        if($category_name->row()->number == 1)
        {
            $errors .= "<li>".$this->lang->line('duplicate_categoryname')."</li>"."\n";
        }
        
        if($errors == "")
        {
            $query = $this->db->query("INSERT INTO categories (name_cat) VALUES('".$data['category']."')");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_categoryadd')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function modify_category($data)
    {
        $errors = "";
        
        if($data['category_name'] == "")
        {
            $errors .= "<li>".$this->lang->line('empty_categoryname')."</li>"."\n";
        }
        
        $category_name = $this->db->query("SELECT COUNT(*) as number FROM categories WHERE name_cat='".$data['category_name']."' AND id_cat !='".$data['id_cat']."'");
        if($category_name->row()->number == 1)
        {
            $errors .= "<li>".$this->lang->line('duplicate_categoryname')."</li>"."\n";
        }
        
        $category = $this->db->query("SELECT COUNT(*) as number FROM categories WHERE id_cat='".$data['id_cat']."'");
        if($category->row()->number == 0)
        {
            $errors .= "<li>".$this->lang->line('invalid_categoryid')."</li>"."\n";
            //$errors .= "<li>This category does not exist (invalid id #".$data['id_cat'].").</li>"."\n"; debug
        }
        
        if($errors == "")
        {
            $update = $this->db->query("UPDATE categories SET name_cat='".$data['category_name']."' WHERE id_cat='".$data['id_cat']."'");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_categorymodify')."</li></ul>");
            
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function delete_category($data)
    {
        $errors = "";
        
        $category = $this->db->query("SELECT COUNT(*) as number FROM categories WHERE id_cat='".$data['id_cat']."'");
        if($category->row()->number == 0)
        {
            $errors .= "<li>".$this->lang->line('invalid_categoryid')."</li>"."\n";
            //$errors .= "<li>This category does not exist (invalid id #".$data['id_cat'].").</li>"."\n"; debug
        }
        
        if($errors == "")
        {
            $projects = $this->db->query("SELECT id_project FROM projects WHERE id_cat='".$data['id_cat']."'");
            
            foreach($projects->result() as $project)
            {
                $task_groups = $this->db->query("SELECT id_group FROM tasks_group WHERE id_project='".$project->id_project."'");
                
                foreach($task_groups->result() as $task_group)
                {
                    $delete_task = $this->db->query("DELETE FROM tasks WHERE id_group='".$task_group->id_group."'");
                }
                
                $delete_task_group = $this->db->query("DELETE FROM tasks_group WHERE id_project='".$project->id_project."'");
            }
            
            $delete_project  = $this->db->query("DELETE FROM projects WHERE id_cat='".$data['id_cat']."'");
            $delete_category = $this->db->query("DELETE FROM categories WHERE id_cat='".$data['id_cat']."'");
            
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_categorydelete')."</li></ul>");
            
        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function add_taskgroup($data)
    {
        $errors = "";
        $members = explode('#', $data['membru'], -1);
        $task    = explode('#', $data['task'], -1);
        
        if($data['name'] == "" || $data['name'] == $this->lang->line('tasks_group_name'))
        {
            $errors .= "<li>".$this->lang->line('empty_taskgroupname')."</li>"."\n";
        }
        
        $group_name = $this->db->query("SELECT COUNT(*) as nr FROM tasks_group WHERE group_name='".$data['name']."' AND id_project='".$data['id_project']."'");
        if($group_name->row()->nr == 1)
        {
            $errors .= "<li>".$this->lang->line('duplicate_taskgroupname')."</li>"."\n";
        }
        
        if($data['deadline'] == "" || $data['deadline'] == $this->lang->line('project_deadline'))
        {
            $errors .= "<li>".$this->lang->line('empty_taskgroupdeadline')."</li>"."\n";
        }
        
        for($i=1; $i<=$data['fieldnumber']; $i++)  
        {
            $k = $i - 1;
            if($task[$k] == $this->lang->line('task_nameinput')) $errors .= "<li>".$this->lang->line('empty_tasknr')." $i !</li>"."\n";
            if($members[$k] == "" || $members[$k] == "0") $errors .= "<li>".$this->lang->line('empty_taskmembernr')." $i !</li>"."\n";
        }

        if($errors == "")
        {
            $segment_date = explode("-", $data['deadline']);
            $deadline = mktime(0, 0, 0, $segment_date[0], $segment_date[1], $segment_date[2]);
            
            $insert = $this->db->query("INSERT INTO tasks_group (id_project, group_name, deadline) VALUES('".$data['id_project']."', '".$data['name']."', '".$deadline."')");
            $id_taskgroup = $this->db->insert_id();
            $time = time();
            
            for($i=0; $i < $data['fieldnumber']; $i++)
            {
                $insert = $this->db->query("INSERT INTO tasks (id_group, id_user, task_name, date_added) VALUES('".$id_taskgroup."', '".$members[$i]."', '".$task[$i]."', '".$time."')");
            }
            
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_taskgroupadd')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul><li>$errors</li></ul>");
        }

        return json_encode($result);
    }
    
    function modify_taskgroup($data)
    {
        $errors = "";

        if($data['name'] == "" || $data['name'] == $this->lang->line('tasks_group_name')) 
        {
            $errors .= "<li>".$this->lang->line('empty_taskgroupname')."</li>"."\n";
        }

        $nr_group = $this->db->query("SELECT COUNT(*) as nr FROM tasks_group WHERE group_name='".$data['name']."' AND id_project='".$data['id_project']."' AND id_group !='".$data['id_group']."'");
        if($nr_group->row()->nr == 1)
        {
            $errors .= "<li>".$this->lang->line('duplicate_taskgroupname')."</li>"."\n";
        }
        
        if($data['deadline'] == "" || $data['deadline'] == $this->lang->line('project_deadline')) {
            $errors .= "<li>".$this->lang->line('empty_taskgroupdeadline')."</li>"."\n";
        }
        
        if($data['fieldnumber'] > 0)
        {
            $members  = explode('#', $data['membru'], -1);
            $task     = explode('#', $data['task'], -1);
            $idtask   = explode('#', $data['idtask'], -1);
        
            for($i=1; $i< $data['fieldnumber']; $i++)
            {
                $k = $i - 1;
                if($task[$k] == $this->lang->line('task_nameinput')) $errors .= "<li>".$this->lang->line('empty_tasknr')." $i !</li>"."\n";
                if($members[$k] == "" || $members[$k] == "0") $errors .= "<li>".$this->lang->line('empty_taskmembernr')." $i !</li>"."\n";
            }
        }


        if($data['newfieldnumber'] > 0)
        {
            $newtask    = explode('#', $data['newtask'], -1);
            $newmembers = explode('#', $data['newmember'], -1);

            for($i=1; $i<= $data['newfieldnumber']; $i++)
            {
                $k = $i - 1;
                if($newtask[$k] == $this->lang->line('task_nameinput')) $errors .= "<li>".$this->lang->line('empty_tasknr')." $i !</li>"."\n";
                if($newmembers[$k] == "" || $newmembers[$k] == "0") $errors .= "<li>".$this->lang->line('empty_taskmembernr')." $i !</li>"."\n";
            }
        }
        
        if($data['fieldnumber'] == 0 && $data['newfieldnumber'] == 0)
        {
            $errors .= "<li>".$this->lang->line('empty_notasks')."</li>"."\n";
        }

        if($errors == "")
        {
            $segment_date = explode("-", $data['deadline']);
            $deadline = mktime(0, 0, 0, $segment_date[0], $segment_date[1], $segment_date[2]);
            
            $update = $this->db->query("UPDATE tasks_group SET group_name='".$data['name']."', deadline='".$deadline."' WHERE id_group='".$data['id_group']."'");
            if($data['fieldnumber'] > 0)
            {
                for($i=0; $i<$data['fieldnumber']-1; $i++)
                {
                    $update = $this->db->query("UPDATE tasks SET id_user='".$members[$i]."', task_name='".$task[$i]."' WHERE id_task='".$idtask[$i]."'");
                }
            }
            $time = time();
            
            if($data['newfieldnumber'] > 0)
            {
                for($i=0; $i < $data['newfieldnumber']; $i++)
                {
                    $insert = $this->db->query("INSERT INTO tasks (id_group, id_user, task_name, date_added) VALUES('".$data['id_group']."', '".$newmembers[$i]."', '".$newtask[$i]."', '".$time."') ");
                }
            }
            
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_taskgroupmodify')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul><li>$errors</li></ul>");
        }

        return json_encode($result);
    }
    
    function update_task($data)
    {
        $errors = "";

        if($data['idtask'] == "") $errors .= "0"."\n";
        if($data['status'] == "") $errors .= "0"."\n";
        
        if($errors == "")
        {
            $update = $this->db->query("UPDATE tasks SET status='".$data['status']."' WHERE id_task='".$data['idtask']."'");
            $result = array("result" => "ok", "result_message" => "0");

        } else {
            $result = array("result" => "null", "result_message" => "0");
        }

        return json_encode($result);
    }
    
    function update_groupname($data)
    {
        $errors = "";

        if($data['id_group'] == "")
        {
            $errors .= "<li>".$this->lang->line('invalid_groupid')."</li>"."\n";
        }
        
        if($data['group_name'] == "")
        {
            $errors .= "<li>".$this->lang->line('empty_groupname')."</li>"."\n";
        }
        
        $group_name = $this->db->query("SELECT COUNT(*) as nr FROM tasks_group WHERE group_name='".$data['group_name']."'");
        if($group_name->row()->nr == 1)
        {
            $errors .= "<li>".$this->lang->line('duplicate_groupname')."</li>"."\n";
        }

        if($errors == "")
        {
            $update = $this->db->query("UPDATE tasks_group SET group_name='".$data['group_name']."' WHERE id_group='".$data['id_group']."'");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_groupmodify')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function delete_grouptasks($data)
    {
        $errors = "";
        $group_task = $this->db->query("SELECT COUNT(*) as grup FROM tasks_group WHERE id_group='".$data['id_group']."' LIMIT 1");
        
        if($data['id_group'] == "" || $group_task->row()->grup < 1)
        {
            $errors .= "<li>".$this->lang->line('invalid_taskgroupid')."</li>"."\n";
        }

        if($errors == "")
        {
            $delete_group = $this->db->query("DELETE FROM tasks_group WHERE id_group='".$data['id_group']."'");
            $delete_task  = $this->db->query("DELETE FROM tasks WHERE id_group='".$data['id_group']."'");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_taskgroupdelete')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function modify_task($data)
    {
        $errors = "";

        if($data['idtask'] == "")
        {
            $errors .= "<li>".$this->lang->line('invalid_taskid')."</li>"."\n";
        }
        
        if($data['task_name'] == "")
        {
            $errors .= "<li>".$this->lang->line('empty_taskname')."</li>"."\n";
        }
        
        if($data['membru'] == "" || $data['membru'] == "0")
        {
            $errors .= "<li>".$this->lang->line('empty_taskmember')."</li>"."\n";
        }

        if($errors == "")
        {
            $update = $this->db->query("UPDATE tasks SET task_name='".$data['task_name']."', id_user='".$data['membru']."' WHERE id_task='".$data['idtask']."'");
            $result = array("result" => "ok", "result_message" => "<ul><li>".$this->lang->line('success_taskmodify')."</li></ul>");

        } else {
            $result = array("result" => "null", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function delete_task($data)
    {
        $errors = "";
        
        $nr_tasks = $this->db->query("SELECT COUNT(*) as nrtask FROM tasks WHERE id_task='".$data['idtask']."'");
        $group_tasks = $this->db->query("SELECT COUNT(*) as nrtasks FROM tasks WHERE id_group='".$data['id_group']."'");
        
        $delete_group = ($group_tasks->row()->nrtasks > 1)? "0":"1";
        
        if($data['id_group'] == "" || $nr_tasks->row()->nrtask < 1)
        {
            $errors .= "<li>".$this->lang->line('invalid_taskgroupid')."</li>"."\n";
        }

        if($errors == "")
        {
            $delete_task = $this->db->query("DELETE FROM tasks WHERE id_task='".$data['idtask']."'");
            $result = array("result" => "ok", "scotgrup" => "$delete_group", "result_message" => "<ul><li>".$this->lang->line('success_taskdelete')."</li></ul>");

        } else {
            $result = array("result" => "null", "scotgrup" => "$delete_group", "result_message" => "<ul>$errors</ul>");
        }
        
        return json_encode($result);
    }
    
    function online_members()
    {
        $id_session    = $this->session->userdata('session_id');
        $id_member     = $this->session->userdata('username');
        $current_time  = time();
        $elapsed_time  = ($current_time - 180); //900 = 15minutes, 180 = 3minutes
        
        $sterge = $this->db->query("DELETE FROM members_online WHERE last_click < '" . $elapsed_time . "'");
        $active_member = $this->db->query("SELECT count(*) as count FROM members_online WHERE id_session = '".$id_session."'");

        if ($active_member->row()->count > 0)
        {
            $update = $this->db->query("UPDATE members_online SET id_user='".$id_member."', last_click='".$current_time."' WHERE id_session='".$id_session."'");
        } else {
            $insert = $this->db->query("INSERT INTO members_online (id_user, id_session, date, last_click) VALUES ('".$id_member."', '".$id_session."', '".$current_time."', '".$current_time."')");
        }
    }
    
    function newtasks_access($id)
    {
        $id_user          = $this->session->userdata('username');
        $query_accessdate = $this->db->query("SELECT access_date, name FROM members WHERE id_user='".$id_user."'");
        $access_date      = $query_accessdate->row()->access_date;
        $time             = time();
        
        if($id == 1)
        {
            $query = $this->db->query("SELECT DISTINCT COUNT(*) as number FROM tasks WHERE id_user='".$id_user."' AND status='0' AND date_added > ".$access_date);
            $new_tasks = $query->row()->number;
            return $new_tasks;
            
        } elseif ($id == 0){
        
            $membername = $query_accessdate->row()->name;
            return $membername;
            
        } else {
            $update_timestamp = $this->db->query("UPDATE members SET access_date='".$time."' WHERE id_user='".$id_user."'");
        }
    }
    
    function member_tasks()
    {
        $id_user = $this->session->userdata('username');
        $nr_tasks = $this->db->query("SELECT COUNT(*) as number FROM projects, tasks_group, tasks WHERE projects.break != '1' AND tasks_group.id_project=projects.id_project AND tasks_group.id_group=tasks.id_group AND tasks.id_user='$id_user' AND tasks.status='0'");
        return $nr_tasks->row()->number;
    }
    
    function project_percentage($id_project)
    {
        $tasks = $this->db->query("SELECT COUNT(*) as number FROM tasks_group, tasks WHERE tasks_group.id_group=tasks.id_group AND tasks_group.id_project='".$id_project."'");
        $tasks_complete = $this->db->query("SELECT COUNT(*) as number FROM tasks_group, tasks WHERE tasks_group.id_group=tasks.id_group AND tasks_group.id_project='".$id_project."' AND tasks.status='1'");
        
        /* percent complete */
        $percentage = ($tasks->row()->number > 0) ? (100 * $tasks_complete->row()->number) / $tasks->row()->number : "0";
        return number_format($percentage,2);
    }
    
    function language_js()
    {
        $languagejs_content = "";
        foreach ($this->lang as $key => $value)
        {
            if($key == 'language')
            {
                foreach ($value as $id => $language)
                {
                    $languagejs_content .= '        '.$id.': "'.$language.'",'."\n";
                }
            }
        }
        
        $languagejs_content = substr($languagejs_content,0,-2);
        $languagejs = 'Language = function()'."\n"
                     .'{'."\n"
                     .'    var phraseBook = {'."\n"
                     .$languagejs_content
                     .'    };'."\n"
            
                     .'    return { translate: function( phrase) { return phraseBook[ phrase]; } };'."\n"
                     .'}();'."\n";
                     
        return $languagejs;
    }
}

?>