$(document).ready(function()
{
    var slideSpd = 200;

    /* DASHBOARD MENU */
    $('ul#control > li').hover(function() {
        dd = $(this).find('a.dropdown').addClass('selected');
        lw = $(this).find('div.link-wrap').slideDown(slideSpd);
    },function() {
        lw.hide();
        dd.removeClass('selected');
    });

    /* TABS */
    $('div#tabs div.inner ul li a').click(function () {
        $('div#project').hide();
        $('div#inner_projects_found').hide();
        $('div#hide_when_searching').show();
        $('div#hide_when_searching > div.tab').hide().filter(this.hash).fadeIn('normal');
        $('div#tabs div.inner ul li a').removeClass('selected');
        $(this).addClass('selected');
        return false;
    });
    
    /* SCROLL TO TOP */
    $("div#footer a.go-top").click(function(event){
        event.preventDefault();
        var full_url = this.href;
        var parts = full_url.split("#");
        var trgt = parts[1];
        var target_offset = $("#"+trgt).offset();
        var target_top = target_offset.top;
        $('html, body').animate({scrollTop:target_top}, 500);
    });

    /* TASK DROPDOWN */
    $('div#task-group div.wrap-task div.inner').click(function () {
        $(this).parent().find('div.drop-task').slideToggle('normal');
        if ($(this).find('span.arrow').hasClass('open')) {
            $(this).find('span.arrow').removeClass('open').addClass('close')
        } else {
            $(this).find('span.arrow').removeClass('close').addClass('open')
        }
    });
    
    /* FIX IE SELECT */
    if ( $.browser.msie ) { $('option').css({'color':'#FFF','background':'#3F3F3C'}); }
    
    $("#project_deadline").datepicker({ dateFormat: 'mm-dd-yy' });

    /* ADD MEMBER + PHOTO */
    if($('#member_photo_action').length)
    {
        checklogin();
        
        jQuery(function(){ 
            var upload = new AjaxUpload(jQuery('#member_photo_action'), {
                action: base_url+'index.php/dashboard/upload_image',
                autoSubmit: false,
                onChange: function(file, ext){
                    $('#member_file').val(file);
                },
                onSubmit: function(file, ext){
                    // Allow only images. You should add security check on the server-side.
                    if (ext && /^(jpg|png|jpeg|gif)$/i.test(ext)) {
                        var id_user = $('#member_id').val();
                        var photo   = $('#member_photo').val();
                        this.setData({
                            'id_user' : id_user,
                            'photo' : photo,
                        });
                    } else {
                        //alert('not image');
                        return false;
                    }
                },
                onComplete: function(file, response){
                    $('#member_id').val('0');
                    $('#member_photo').val('0');
                }
            });
            jQuery('#addmember').click(function(){
                add_member();
                setTimeout(function() {
                    var result = $('#member_add_done').val();
                    if(result == 1) {
                        upload.submit();
                    }
                } , 1000);
                setTimeout(function() { 
                    $('#users').load(base_url+"index.php/dashboard/view_controller/box_member_online");
                } , 3000);
                //upload.enable();
                return false;
            });
        });
    }
    
    /* calendar initialization. */
    calendar();
});



/* GENERAL MODAL - BOX */
function modal(id)
{
    checklogin();
    
    var idbox = $(id);
    var maskHeight = $(document).height();
    var maskWidth = $(window).width();

    $('#mask').css({'width':maskWidth,'height':maskHeight});
    $('#mask').fadeIn(200);
    $('#mask').fadeTo("fast",0.6);

    var winH = $(window).height();
    var winW = $(window).width();

    $(idbox).css('top',  winH/2-$(idbox).height()/2);
    $(idbox).css('left', winW/2-$(idbox).width()/2);

    $(idbox).fadeIn(300);
}

/* ADD A NEW PROJECT */
function addproject()
{
    checklogin();
    
    var name        = $('#project_name').val();
    var description = $('#project_description').val();
    var category    = $('#project_category').val();
    var deadline    = $('#project_deadline').val();
    var location    = $('#menu_location').val();
    
    $.post(base_url+"index.php/dashboard/add_project", {name: name, description: description, category: category, deadline: deadline},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_project','error',data.result_message);
            }
            
            if(data.result=="ok") {
                responce_display('#error_project','ok',data.result_message);
                
                if(location == 0)
                {
                    $('#tabs').load(base_url+"index.php/dashboard/view_controller/box_categories");
                    $('#content').load(base_url+"index.php/dashboard/view_controller/box_categories_content", function() {
                        $('#loading_page').hide();
                    });
                    
                }

                /* reset values */
                $('#project_name').val(Language.translate("project_name")); 
                $('#project_deadline').val(Language.translate("project_deadline")); 
                $('#project_description').val(Language.translate("project_description"));
                $('#project_category').val(0);
            }

    }, "json");
}

/* MODIFY PROJECT */
function modifyproject(id_project)
{
    checklogin();
    
    var name        = $('#mod_project_name').val();
    var description = $('#mod_project_description').val();
    var category    = $('#mod_project_category').val();
    var deadline    = $('#mod_project_deadline').val();
    var location    = $('#menu_location').val();
    
    $.post(base_url+"index.php/dashboard/modify_project", {name: name, description: description, category: category, deadline: deadline, id_project: id_project},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_modifyproject','error',data.result_message);
            }
            
            if(data.result=="ok") {
                responce_display('#error_modifyproject','ok',data.result_message);

                $('#tabs').load(base_url+"index.php/dashboard/view_controller/box_categories");
                $('#content').load(base_url+"index.php/dashboard/view_controller/box_categories_content", function() {
                        $('#loading_page').hide();
                });
            }

    }, "json");
}

/* ADD A NEW TEAM MEMBER */
function add_member()
{
    checklogin();
    
    var name      = $('#member_name').val();
    var username  = $('#member_username').val();
    var ocupation = $('#member_ocupation').val();
    var email     = $('#member_email').val();
    var phone     = $('#member_phone').val();
    var password1 = $('#member_password1').val();
    var password2 = $('#member_password2').val();
    var access    = $('#member_rank').val();
    
    $.post(base_url+"index.php/dashboard/add_member", {name: name, username: username, ocupation: ocupation, access: access, email: email, phone: phone, password1: password1, password2: password2},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_members','error',data.result_message);
                $('#member_add_done').val('0');
            }
            if(data.result=="ok") {
                responce_display('#error_members','ok',data.result_message);
                
                /* values for loading the picture */
                $('#member_id').val(data.id_user);
                $('#member_add_done').val('1');
                
                /* reset values */
                $('#member_name').val(Language.translate("name_and_surname"));
                $('#member_username').val(Language.translate("username"));
                $('#member_ocupation').val(Language.translate("member_ocupation"));
                $('#member_email').val(Language.translate("member_email"));
                $('#member_phone').val(Language.translate("member_phone"));
                $('#member_password1').val('123456789');
                $('#member_password2').val('123456789');
                $('#member_file').val('');
                
            }
        }, "json");
}

/* ADD A NEW CATEGORY */
function addcategory()
{
    checklogin();
    
    var category = $('#category_name').val();
    var location = $('#menu_location').val();
    
    $.post(base_url+"index.php/dashboard/add_category", {category: category},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_category','error',data.result_message);
            }
            
            if(data.result=="ok") {
                responce_display('#error_category','ok',data.result_message);
                
                if(location == 0)
                {
                    $('#tabs').load(base_url+"index.php/dashboard/view_controller/box_categories");
                    //$('#content').load(base_url+"index.php/dashboard/view_controller/box_categories_content");
                    $('#content').load(base_url+"index.php/dashboard/view_controller/box_categories_content", function() {
                        $('#loading_page').hide();
                    });
                }
                
                $('#box_category').load(base_url+"index.php/dashboard/view_controller/box_project_category");
                $('#box_managecategories').load(base_url+"index.php/dashboard/view_controller/box_categories_manage");
                
                /* reset values */
                $('#category_name').val(Language.translate("category_name"));
            }

    }, "json");
}

/* MODIFY CATEGORY */
function modify_category(id_cat)
{
    checklogin();
    
    var id_cat = id_cat;
    var category_name = $('#input_category'+id_cat).val();
    
    $.post(base_url+"index.php/dashboard/modify_category", {id_cat: id_cat, category_name: category_name},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_managecategory','error',data.result_message);
            }
            
            if(data.result=="ok"){
                responce_display('#error_managecategory','ok',data.result_message);
                dashboard();
                
                $('#box_managecategories').load(base_url+"index.php/dashboard/view_controller/box_categories_manage");
                $('#box_category').load(base_url+"index.php/dashboard/view_controller/box_project_category");
            }

    }, "json");
}

/* DELETE CATEGORY */
function delete_category(id_cat)
{
    checklogin();
    
    var id_cat = id_cat;
    
    $.post(base_url+"index.php/dashboard/delete_category", {id_cat: id_cat},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_managecategory','error',data.result_message);
            }
            
            if(data.result=="ok"){
                responce_display('#error_managecategory','ok',data.result_message);
                dashboard();
                $('#box_managecategories').load(base_url+"index.php/dashboard/view_controller/box_categories_manage");
                hideboxmodal('#alert_delete_category','#categories');
            }

    }, "json");
}

/* ADD A NEW CLIENT */
function addclient()
{
    checklogin();
    
    var name        = $('#client_name').val();
    var description = $('#client_description').val();
    var phone       = $('#client_phone').val();
    var email       = $('#client_email').val();
    var location    = $('#menu_location').val();
    
    $.post(base_url+"index.php/dashboard/add_client", {name: name, description: description, phone: phone, email: email},
    
        function(data) {
            if(data.result=="null"){
                responce_display('#error_client','error',data.result_message);
            }
            
            if(data.result=="ok") {
                responce_display('#error_client','ok',data.result_message);
                
                if(location == 0)
                {
                    $('#tabs').load(base_url+"index.php/dashboard/view_controller/box_categories");
                    $('#content').load(base_url+"index.php/dashboard/view_controller/box_categories_content", function() {
                        $('#loading_page').hide();
                    });
                }
                
            }

    }, "json");
}

/* PROJECT FUNCTIONS */
function project_view(idcat, id_project, category)
{
    checklogin();
    
    if (!auxx) {
        auxx = idcat;
        $.get(base_url+"index.php/dashboard/view_controller/box_project/"+idcat+"/"+id_project,
        function(data) { 
            $("#project").html(data);
            $("#project").fadeIn('slow');
            if(category == '0') {
                $("#inner_projects_found").hide();
            } else {
                $("#"+category).hide();
            }
            auxx = "";
        });
        $('#box_addtask').load(base_url+"index.php/dashboard/view_controller/box_grouptask_add/"+idcat+"/"+id_project);
    }
    $('#greeting').load(base_url+"index.php/dashboard/view_controller/box_tasks_update");
}

function searchproject()
{
    checklogin();
    
    var searched_word = $('#searchproject').val();
    
    $.post(base_url+"index.php/dashboard/search_project", {searched_word: searched_word},
        function(data) {
            if(data.result=="null"){
                $('#hide_when_searching').hide();
                $('#project').hide();
                $('#inner_projects_found').load(base_url+"index.php/dashboard/view_controller/box_project_search/0");
                $('#inner_projects_found').show();
            }
            if(data.result=="ok") {

                $('#hide_when_searching').hide();
                $('#project').hide();
                $('#inner_projects_found').load(base_url+"index.php/dashboard/view_controller/box_project_search/"+data.result_message);
                $('#inner_projects_found').show();
            }
    }, "json");
}

function my_tasks()
{
    checklogin();
    
    $('#main').load(base_url+"index.php/dashboard/view_controller/box_mytasks");
    $('#users').load(base_url+"index.php/dashboard/view_controller/box_member_online");
    $('#box_addtask').load(base_url+"index.php/dashboard/view_controller/box_tasks_operations");
    $('#menu_location').val('1');
}

function dashboard()
{
    checklogin();
    
    $('#main').load(base_url+"index.php/dashboard/view_controller/box_dashboard");
    $('#users').load(base_url+"index.php/dashboard/view_controller/box_member_online");
    $('#menu_location').val('0');
}

function archive(id_archive,interval)
{
    checklogin();
    
    $('#main').load(base_url+"index.php/dashboard/view_controller/tab_archive/"+id_archive+"/"+interval);
    $('#users').load(base_url+"index.php/dashboard/view_controller/box_member_online");
    $('#inner_member_nrtasks').load(base_url+"index.php/dashboard/view_controller/box_member_tasknr");
    $('#menu_location').val('1');
}

function update_modifymember(iduser)
{
    checklogin();
    
    $('#box_member_modify').load(base_url+"index.php/dashboard/view_controller/box_member_modify/"+iduser, function() {
        modal('#modify-member');
    });
}

function update_deletemember(iduser)
{
    checklogin();
    
    $('#box_member_modify').load(base_url+"index.php/dashboard/view_controller/box_member_modify/"+iduser, function() {
        modal('#delete_member');
    });
}

function update_infomember(iduser)
{
    checklogin();
    
    $('#box_member_details').load(base_url+"index.php/dashboard/view_controller/box_member_details/"+iduser, function() {
        modal('#user'+iduser);
    });
}

function hideboxmember(id_user)
{
    $('#user'+id_user).hide();
    $('#user'+id_user).remove();
    $('#mask').hide();
}

function hideboxmodal(id,second)
{
    $(id).hide();
    $(second).fadeTo("fast", 1);
}

function fadebox(id)
{
    $(id).fadeTo("fast", 0.2);
}

function calendar(month,year)
{
    checklogin();
    
    $('#boxcalendar').load(base_url+"index.php/dashboard/view_controller/box_calendar/"+month+"/"+year);
}

function responce_display(id,message,responce)
{
    if(message == 'error')
    {
        $(id).html(responce);
        $(id).removeClass();
        $(id).addClass('message-error');
        $(id).show();
    } else {
        $(id).html(responce);
        $(id).removeClass();
        $(id).addClass('message-ok');
        $(id).show();
    }
    
}

function form_deletecategory(id_cat)
{
    checklogin();
    
    var button = "<span class=\"btn mlt\">&nbsp;</span><span class=\"btn-bg\" onclick=delete_category('"+id_cat+"');>Delete</span><span class=\"btn mrt\">&nbsp;</span></a>";
    $("#delete_category_button").html(button);
}

function managecategories()
{
    checklogin();
    
    $('#box_managecategories').load(base_url+"index.php/dashboard/view_controller/box_categories_manage", function() {
        modal('#categories');
    });
}

/* check if user in logged in */
function checklogin()
{
    var login;
    $.post(base_url+"index.php/dashboard/checklogin", {login: login},
        function(data) {
            if(data.result=="null"){

            }
            if(data.result=="ok") {
                if(data.result_message == 1) window.location = base_url;
            }
    }, "json");
}